import shapefile
import math
from os import path
import numpy as np

def comp_ishape(d_init, ishape_last, days_1950, eddy_index):
    k = days_1950 - d_init
    
    if k == 0:
        ishape = eddy_index - 1
    else:
        ishape = ishape_last[k - 1] + eddy_index
        
    return ishape

def in_window(point, window):
    llcrnrlon, llcrnrlat, urcrnrlon, urcrnrlat = window
    longit = point[0] + math.ceil((llcrnrlon - point[0]) / 360) * 360
    # (in [llcrnrlon, llcrnrlon + 360[)

    return longit <= urcrnrlon and llcrnrlat <= point[1] <= urcrnrlat

def open_shpc(shpc_dir):
    readers = {}
    
    for layer in ["extremum", "outermost_contour", "max_speed_contour"]:
        try:
            readers[layer] = shapefile.Reader(path.join(shpc_dir, layer))
        except shapefile.ShapefileException:
            print(f"Shapefile {layer} not found in {shpc_dir}.")

    d_init = readers["extremum"].record(0).days_1950
    fname = path.join(shpc_dir, "ishape_last.txt")
    
    try:
        ishape_last = np.loadtxt(fname, dtype = int, ndmin = 1)
    except OSError:
        print("Could not read", fname)
        ishape_last = None

    return readers, d_init, ishape_last
