program test_read_eddy

  ! Libraries:
  use mpi_f08, only: mpi_init, mpi_finalize

  use derived_types, only: eddy, shpc
  use read_eddy_m, only: read_eddy
  use shpc_close_m, only: shpc_close
  use shpc_create_m, only: shpc_create
  use shpc_open_m, only: shpc_open
  use write_eddy_m, only: write_eddy

  implicit none

  type(eddy) e
  integer k, i
  TYPE(shpc) hshp

  !-------------------------------------------------------------------------

  call mpi_init
  call shpc_open(hshp, "SHPC_old", rank = 0)
  call read_eddy(e, k, i, hshp, ishape = 0)
  CALL shpc_close(hshp)

  call shpc_create(hshp, shpc_dir = "SHPC", cyclone = hshp%cyclone)
  call write_eddy(e, hshp, k, i)
  CALL shpc_close(hshp)
  print *, 'Created shapefiles in SHPC.'
  call mpi_finalize

end program test_read_eddy
