program test_write_overlap

  use, intrinsic:: ISO_FORTRAN_ENV

  use derived_types, only: shpc
  use shpc_close_m, only: shpc_close
  use shpc_create_m, only: shpc_create
  use unit_edge_m, only: open_edge_file, unit_edge
  use write_overlap_m, only: write_overlap, init_interpolated_eddy

  implicit none

  integer j_interp
  integer:: k = 2, delta = 1, m = 0
  real:: coord_extr_1(2) = [0., 0.], coord_extr_2(2) = [0., 0.] ! in rad
  real:: ssh_extr_1 = 0., ssh_extr_2 = 0.
  TYPE(shpc) hshp
  namelist /main_nml/ k, delta, m, coord_extr_1, ssh_extr_1, coord_extr_2, &
       ssh_extr_2

  !-------------------------------------------------------------------------

  write(unit = error_unit, nml = main_nml)
  write(unit = error_unit, fmt = *) "Enter namelist main_nml."
  read(unit = *, nml = main_nml)
  write(unit = *, nml = main_nml)
  
  call open_edge_file(rank = 0)

  ! Title lines:
  write(unit_edge, fmt = "(1x, a)") '"predecessor date subscript" ' &
       // '"predecessor eddy subscript" "successor date subscript" ' &
       // '"successor eddy subscript"'
  write(unit_edge, fmt = *) "k1 i1 k2 i2 weight"
  
  call shpc_create(hshp, shpc_dir = "SHPC", cyclone = .true.)
  call init_interpolated_eddy
  call write_overlap(hshp, k, delta, i1 = 1, i2 = 2, m = m, &
       i_interp = 10 + [(j_interp, j_interp = 1, delta - 1)], &
       cyclone = .true., coord_extr_1 = coord_extr_1, ssh_extr_1 = ssh_extr_1, &
       coord_extr_2 = coord_extr_2, ssh_extr_2 = ssh_extr_2, w = 0.)
  close(unit_edge)
  print *, 'Created file "edgelist.csv".'
  CALL shpc_close(hshp)
  print *, 'Created shapefiles in SHPC.'

end program test_write_overlap
